#include "fft_avg_complex.h"

#include <iostream>

fft_avg_complex::fft_avg_complex(int n, t_fft_window fft_window):fftw_base(n, fft_window)
{
    fft_sum_ = new double[n_];
    fft_out_temp_ = new double[(int) n_ ];
}



fft_avg_complex::~fft_avg_complex()
{
    delete[] fft_sum_;
    delete[] fft_out_temp_;
}


void fft_avg_complex::add_fft(double data_in_real[], double data_in_imag[]) {
    complex_fft_linear_power(data_in_real, data_in_imag, fft_out_temp_);

    for (int i = 0; i < n_; i++)
        fft_sum_[i] += fft_out_temp_[i];

    num_ffts_++;

}



void fft_avg_complex::reset() {
    num_ffts_ = 0;

    for (int i=0; i<n_; i++)
        fft_sum_[i] = 0;

}

void fft_avg_complex::get_avg_fft(double output_avg_fft_mag[]) {
    for (int i = 0; i < n_; i++)                  // average linear power spectrum
        output_avg_fft_mag[i] = fft_sum_[i] / num_ffts_;

    linear2dbm_complex(output_avg_fft_mag);            //convert to dBm scale
    correct_coherent_gain_complex(output_avg_fft_mag); //correct coherent power gain

}
