#include "fft_avg_real.h"

#include <iostream>

fft_avg_real::fft_avg_real(int n, t_fft_window fft_window):fftw_base(n, fft_window)
{
    fft_sum_ = new double[ (int) n_/2 ];
    fft_out_temp_ = new double[(int) n_/2 ];
}



fft_avg_real::~fft_avg_real()
{
    delete[] fft_sum_;
    delete[] fft_out_temp_;
}


void fft_avg_real::add_fft(double data_in[]) {
    real_fft_linear_power(data_in, fft_out_temp_);

    for (int i = 0; i < n_/2; i++)
        fft_sum_[i] += fft_out_temp_[i];

    num_ffts_++;

}


void fft_avg_real::reset() {
    num_ffts_ = 0;

    for (int i = 0; i < n_/2; i++)
        fft_sum_[i] = 0;
}


void fft_avg_real::get_avg_fft(double output_avg_fft_mag[]) {

    for (int i = 0; i < n_/2; i++)                  // average linear power spectrum
        output_avg_fft_mag[i] = fft_sum_[i] / num_ffts_;

    linear2dbm_real(output_avg_fft_mag);            //convert to dBm scale
    correct_coherent_gain_real(output_avg_fft_mag); //correct coherent power gain

}
